# 配置介绍

::: details 目录
[[toc]]
:::

**简介**

通过配置文件可以快速定义3D场景的基本信息 例如背景色 相机的默认位置 角度等信息

::: details 结构说明

```json5
{
    //设置整个工程的模型请求地址
    "Url": {
        "burl": "http://47.104.108.133:8082/",
        "rurl": "api/WebMeshProvider/"
    },
    //场景中其他逻辑类设置
    "Other":{
        "WebView":{//Tooltip设置
            "MaxViewNumber":30//场景中最多同时显示的Web面板的数量
        },
        "CameraMove":{//相机定位设置
            "Angle":45,//相机与目标点的角度
            "Scale":20//相机与目标点的距离
        }
    },
    //设置当前场景的默认属性信息
    "Scene": {
        "background": "#151c2a"
    },
    //设置场景中的辅助显示 例如帧率 世界坐标系等
    "SceneShowConfig":{
        "IsShowHellp":false,//是否显示场景的帧率以及世界坐标辅助线
        "IsSaveBgFileContent":false//是否保存SourceID对应的Bg文件等相关所有信息
    },
    //当前场景相机的默认属性信息
    "Camera": {
        "set_position": [0, 0, 0],
        "set_rotation": [0, 0, 0],
        "set_up": [0, 0, 1]
    },
    //当前场景控制器默认控制属性信息
    "Controls": {
        "set_target": [0, 0, 0],//世界场景中心点
        "minDistance": 0,//最小缩放距离
        "maxDistance": 100000,//最大缩放距离
        "minPolarAngle": 3,//最小仰角
        "maxPolarAngle": 89,//最大仰角
        "enableDamping":false,//场景是否开启阻尼
        "dampingFactor":0.05//默认阻尼系数
    },
    //当前场景灯光默认属性信息
    "Light": {
        //平行光
        "DirectionalLight": {
            "set_position": [1, -1, 4],
            "color": "#ffffff"
        },
        //环境光
        "AmbientLight": {
            "color": "#777777"
        }
    },
    //材质信息
    "Material": {
        //整个场景加载模型默认显示材质
        "DefaultMaterial": {
            "matType": "MeshPhongMaterial",//材质类型
            "color": "#ffffff",
            "transparent": true
        },
        //定义工程中所有通用的系统专业默认显示的材质信息
        "System": {
            "OST_PipeCurves": {
                "key":"***",//去System层级下超找属性进行原子合并
                "color": "#0088f9"
            }
        },
        //自定义类型默认显示的材质信息
        "CustomGroup": {
            "AllBaoJingEqState": {
                "contentMessage": "所有报警设备显示的样式",
                "key":"***",//去CustomGroup层级下超找属性进行原子合并
                "color": "#CB3F79"
            }
        }
    },
    //设置素有非文件系统的模型矩阵信息
    "Matrix": {
        //保存所有通用的自定义类型矩阵信息
        "CustomGroup": {
            "TwoSceneQiangTi":{
                //位置
                "position":{
                    "x":0,
                    "y":0,
                    "z":0
                },
                //角度
                "rotation":{
                    "x":0,
                    "y":0,
                    "z":0
                },
                //缩放                                      
                "scale":{
                    "x":0,
                    "y":0,
                    "z":0
                }
            }
        }
    },
    //每个楼层需要加载的管件类型列表
    "Load_OST":[
        {
            "name": "OST_MechanicalEquipment",
            "CName": "机械设备"
        }
    ]
}
```

:::
