# PEMessage

::: details 目录
[[toc]]
:::

## 简介

负责订阅事件通知 

前端与引擎通过指令进行通信需要使用该类进行通信

<font color=red>组件从内存中释放的时候记得调用off函数注销监听事件</font>

## 实例方法

### on 注册事件

```js
/**
 *UI注册事件
 *
 * @param {*} type
 * @param {*} block (data)=>{}
 * @memberof PEMessage
 */
on(type, block) {}

//eg: data的内容
this.message.on('**',(data)=>{
    //....
})
```

### onMerge 注册一组事件 只有监听的事件全都执行完成才会执行回调函数

```js
/**
 *监听一组事件 只有事件全都执行完成才会执行回调函数
 *
 * @param {*} typeList
 * @param {*} event (dic)=>{} dic {type:data}
 * @memberof PEMessage
 */
onMerge(typeList,event){}
```

### onMergeAny 监听一组事件 其中任意一个执行完成就开始回调通知

```js
/**
 *监听一组事件 只有事件全都执行完成才会执行回调函数
 *
 * @param {*} typeList
 * @param {*} event (dic)=>{} dic {type:data}
 * @memberof PEMessage
 */
onMergeAny(typeList,event){}
```

### emit 给3D发送事件

```js
/**
 *发送事件
 *
 * @param {*} type
 * @param {*} data
 * @memberof PEMessage
 */
emit(type, data) {}
```

### off 注销当前对象注册的所有事件通知

```js
/**
 *注销事件
 *
 * @memberof PEMessage
 */
off() {}
```

### addMiddleware 注册指令过滤的中间件

## 静态方法

### emitMessage 发送消息 通过该函数发送的消息会立刻执行,不管当前是否还有正在执行的消息列表

```js
/**
 *向3D发送消息
 *
 * @static
 * @param {*} message
 * @memberof PEMessage
 */
 static emitMessage(message){}
```

### emitMessageList 发送消息列表

```js
/**
 *向3D发送消息列表
 *
 * @param {*} messageList
 * @memberof PEMessage
 */
static emitMessageList(messageList) {}
```