# 设置模型后期处理

::: details 目录
[[toc]]
:::

**注意事项**

<font color=red>后期效果对想能损耗比较明显,但是目前代码逻辑并没有对前端做任何限制,所以需要根据具体业务场景酌情使用</font>

## 发光外轮廓

**逻辑说明**

当收到PEAddOutLine一个指令之后会根据ObjectID列表对应的Config配置信息做判断是否需要重新初始一个新的后期对象用于显示轮廓,例如两个配置不同的ObjectList会初始化两个对象,如果配置相同则使用同一个对象显示这些ObjectList的轮廓,初始对象越多性能越差,所以需要尽力避免使用不同的配置效果。


### 添加外轮廓

::: details 完整结构

```json5
{
        "CmdName": "PESetMeshEspecially",
        "Time": "",
        "Platform": "",
        "CmdParams": {

        },
        "OrderList": [{
                "OrderName": "PEAddOutLine",//为模型添加外轮廓
                "OrderParams": {
                    "ObjectID": [],//--必填-- SourceID列表
                    "Config":{//轮廓的默认配置参数
                        "edgeStrength": 10,//轮廓边缘强度 可以认为是轮廓粗细
                        "edgeGlow": 0,//轮廓泛光强度 
                        "edgeThickness": 2,//轮廓泛光浓度
                        "pulsePeriod": 0,//轮廓闪烁频率 默认0 表示不闪烁
                        "visibleEdgeColor": "#010793",//没有遮挡区域的轮廓显示颜色
                        "hiddenEdgeColor": "#010793"//遮挡轮廓的显示颜色
                    }
                }
            }
        ]
    }
```

:::

### 删除外轮廓

::: details 完整结构

```json5
{
        "CmdName": "PESetMeshEspecially",
        "Time": "",
        "Platform": "",
        "CmdParams": {

        },
        "OrderList": [
            {
                "OrderName": "PERemoveOutLine",//删除外轮廓
                "OrderParams": {
                    "ObjectID": []//--必填--
                }
            }
        ]
    }
```

:::