## 非TS环境如何开发
注：开发过程中，底层包有时候不能满足当前需求，需要开发同事基于当前引擎包二次开发；
由于底层包开发时通过typeScript开发，所以如何让非TS项目开发引入开发尤为重要；
（不需要二次拓展的忽略此模块）
### 步骤一 全局安装 typeScript

```js
  npm install -g typescript
```
### 步骤二 在脚手架 package.json 同级目录 添加 tsconfig.json文件

```js
  {
    "compilerOptions": {
        "target": "es6",
        "module": "es2015",
        "moduleResolution": "node",
        "allowSyntheticDefaultImports": true,
        "experimentalDecorators": true,
        "lib": [
            "dom",
            "es5",
            "es2015",
            "es2015.promise"
        ],
        "strict": true
    },
    "include": [
        "src/**/*.ts",
    ],
    "exclude": [
        "node_modules"
    ]
}
```

### 步骤三 该项目下启动实时编译

 ```js
 tsc -w
 ```
